"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var glob_1 = require("../../utils/glob");
var pall_1 = require("../../utils/pall");
var path_1 = require("path");
var fs_1 = require("mz/fs");
var Copy = /** @class */ (function () {
    function Copy(root, glob) {
        var _this = this;
        this.root = root;
        this.glob = glob;
        this.files = [];
        this.emit = function (compilation) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var files, _a, contents, _loop_1, this_1, i;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, glob_1.default(this.root, this.glob)
                            // get the contents in parallel
                        ];
                    case 1:
                        files = _a.files = _b.sent();
                        return [4 /*yield*/, pall_1.default(files.map(function (file) { return fs_1.readFile(file, 'utf8'); }))];
                    case 2:
                        contents = _b.sent();
                        if (contents instanceof Error)
                            throw Error;
                        _loop_1 = function (i) {
                            var file = path_1.relative(this_1.root, files[i]);
                            var content = contents[i];
                            compilation.assets[file] = {
                                size: function () { return file.length; },
                                source: function () { return content; },
                            };
                        };
                        this_1 = this;
                        for (i = 0; i < files.length; i++) {
                            _loop_1(i);
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        this.afterEmit = function (compilation) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var deps, files, i;
            return tslib_1.__generator(this, function (_a) {
                deps = compilation.fileDependencies;
                files = this.files;
                for (i = 0; i < files.length; i++) {
                    if (deps.has(files[i]))
                        continue;
                    deps.add(files[i]);
                }
                return [2 /*return*/];
            });
        }); };
    }
    Copy.prototype.apply = function (compiler) {
        compiler.hooks.emit.tapPromise('copy', this.emit);
        compiler.hooks.afterEmit.tapPromise('copy', this.afterEmit);
    };
    return Copy;
}());
exports.default = Copy;
